################################################################################################
#
# Doors
#
################################################################################################

scoreboard objectives add rc minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add sneak minecraft.custom:minecraft.sneak_time
scoreboard objectives add talk minecraft.custom:minecraft.talked_to_villager
scoreboard objectives add stone_rot dummy
scoreboard objectives add p_rot dummy
scoreboard objectives add stone_open dummy
scoreboard objectives add book_open dummy
scoreboard objectives add cloud_door dummy
scoreboard objectives add circle_charge dummy
scoreboard objectives add ET dummy


gamerule logAdminCommands false
gamerule sendCommandFeedback false
gamerule commandBlockOutput false




effect give @e[tag=iv] invisibility 99 9 true



################################################################# Give ################################################################

give @a[tag=give] minecraft:endermite_spawn_egg{display:{Name:"{\"text\":\"Stone Trap Door\"}"},EntityTag:{id:"minecraft:endermite",Tags:["sp1","sp"]}}
give @a[tag=give] minecraft:endermite_spawn_egg{display:{Name:"{\"text\":\"Bookshelf Door\"}"},EntityTag:{id:"minecraft:endermite",Tags:["sp2","sp"]}}
give @a[tag=give] minecraft:endermite_spawn_egg{display:{Name:"{\"text\":\"Particle Door\"}"},EntityTag:{id:"minecraft:endermite",Tags:["sp3","sp"]}}
give @a[tag=give] minecraft:endermite_spawn_egg{display:{Name:"{\"text\":\"Reverse Door\"}"},EntityTag:{id:"minecraft:endermite",Tags:["sp5","sp"]}}
give @a[tag=give] minecraft:endermite_spawn_egg{display:{Name:"{\"text\":\"Cloud Door\"}"},EntityTag:{id:"minecraft:endermite",Tags:["sp4","sp"]}}
give @a[tag=give] minecraft:tnt{display:{Name:"{\"text\":\"Remove Door\"}"}} 64
give @a[tag=give] minecraft:diamond_pickaxe{Unbreakable:1,display:{Name:"{\"text\":\"Magnifying Glass\"}"},Damage:5,HideFlags:63} 1




############################################################### Rotation #############################################################

scoreboard players set @a[y_rotation=-45..45] p_rot 1
scoreboard players set @a[y_rotation=46..134] p_rot 2
scoreboard players set @a[y_rotation=-134..-46] p_rot 4
scoreboard players set @a[y_rotation=-180..-134] p_rot 3
scoreboard players set @a[y_rotation=134..180] p_rot 3





#################################################################### Reverse Door #############################################################

execute at @e[tag=rev_door] run execute as @a[distance=..3] at @s run function npc:init
execute at @e[tag=rev_door] run execute as @a[distance=..3] at @s run function npc:main
execute at @e[tag=rev_door] run tag @a[distance=..3] add NPCEntity



execute at @e[tag=sp5] run summon armor_stand ~ ~ ~ {Tags:["rev_door","rev_door1"],NoGravity:1,Invisible:1}



tag @a[tag=placer] remove placer
kill @e[tag=rev_init]
kill @e[tag=sp5]

execute at @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b}] run tag @e[tag=rev_door,distance=..2] add rev_kill
execute at @e[tag=rev_kill] run particle smoke ~ ~1 ~ 0.3 0.3 0.3 0.05 40 force
execute at @e[tag=rev_kill] run kill @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b}] 
kill @e[tag=rev_kill]




execute at @e[tag=rev_door] run execute at @a[distance=..0.5,scores={var=1800}] run playsound minecraft:entity.enderman.teleport master @a
execute at @e[tag=rev_door] run tp @a[distance=..0.5,scores={var=1800}] ~ ~-2 ~ 





################################################################## Particle Door ############################################################

execute at @e[tag=sp3] run summon armor_stand ~ ~ ~ {Tags:["comb_door"],NoGravity:1,Invisible:1}
execute at @e[tag=sp3] run summon armor_stand ~ ~ ~ {Tags:["comb_door_c"],NoGravity:1,Invisible:1}
execute at @e[tag=sp3] run fill ~ ~-2 ~ ~ ~-3 ~ air 
kill @e[tag=sp3]

execute as @e[tag=comb_door] at @s run tp @s ~ ~ ~ ~5 ~
execute as @e[tag=comb_door] at @s run tp @e[tag=comb_door_c] ^ ^ ^2
execute at @a[nbt={SelectedItem:{id:"minecraft:diamond_pickaxe",tag:{display:{Name:"{\"text\":\"Magnifying Glass\"}"}}}}] run execute as @e[tag=comb_door] at @s run particle enchant ^ ^ ^2 0 0 0 0.1 10
execute at @a[nbt={SelectedItem:{id:"minecraft:diamond_pickaxe",tag:{display:{Name:"{\"text\":\"Magnifying Glass\"}"}}}}] run execute as @e[tag=comb_door] at @s run particle portal ~ ~0.2 ~ 0 0 0 0.3 1


scoreboard players add @e[tag=comb_door] circle_charge 0
scoreboard players remove @e[tag=comb_door,scores={circle_charge=1..}] circle_charge 1
execute at @e[tag=comb_door] run execute as @a[distance=..0.2] at @s positioned ~ ~1.65 ~ run execute as @s positioned ^ ^ ^2.2 run execute as @e[tag=comb_door_c,distance=..0.9,limit=1,sort=nearest] run scoreboard players add @e[tag=comb_door,limit=1,sort=nearest] circle_charge 2
execute at @e[tag=comb_door] run execute as @a[distance=..0.2] at @s positioned ~ ~1.65 ~ run execute as @s positioned ^ ^ ^2.2 run execute as @e[tag=comb_door_c,distance=..0.9,limit=1,sort=nearest] run particle flame ~ ~ ~ 0 0 0 0.01 1


execute at @e[tag=comb_door,scores={circle_charge=60..}] run tag @a[distance=..0.16] add enter
execute at @e[tag=comb_door,scores={circle_charge=60..}] run execute as @a[distance=..0.16] at @s run scoreboard players set @e[tag=comb_door,scores={circle_charge=60..},limit=1,sort=nearest] circle_charge 0
execute as @a[tag=enter] at @s run playsound minecraft:entity.enderman.teleport master @a 
execute as @a[tag=enter] at @s run tp @s ~ ~-2 ~ 
tag @a[tag=enter] remove enter


execute at @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b}] run tag @e[tag=comb_door,distance=..2] add comb_kill
execute at @e[tag=comb_kill] run data merge entity @e[tag=comb_door_c,limit=1,sort=nearest] {Health:0,DeathTime:19}
execute at @e[tag=comb_kill] run particle smoke ~ ~1 ~ 0.3 0.3 0.3 0.05 40 force
execute at @e[tag=comb_kill] run kill @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b}] 
kill @e[tag=comb_kill]





############################################################## Stone Door #############################################################

scoreboard players add @e[tag=stone_door] stone_rot 0
execute as @e[tag=stone_door] run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s stone_rot


execute as @e[tag=sp1] at @s align xyz run summon villager ~0.5 ~-1.5 ~0.5 {Tags:["stone_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute as @e[tag=sp1] at @s align xyz run summon armor_stand ~0.5 ~-1.5 ~0.5 {Tags:["stone_init"]}
execute as @e[tag=sp1] at @s run tag @p add placer
effect give @e[tag=stone_villager] invisibility 99 9 true
execute at @a[tag=placer,scores={p_rot=1},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[0f],Tags:["stone_door","stone_rot1"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:0},Count:1}],NoGravity:1,Pose:{Head:[0f,0.000001f,0f]},Invisible:1}
execute at @a[tag=placer,scores={p_rot=1},limit=1] run execute at @e[tag=stone_init] run fill ~ ~1 ~ ~1 ~1 ~ stone
execute at @a[tag=placer,scores={p_rot=2},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[90f],Tags:["stone_door","stone_rot2"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:0},Count:1}],NoGravity:1,Pose:{Head:[0f,0.000001f,0f]},Invisible:1}
execute at @a[tag=placer,scores={p_rot=2},limit=1] run execute at @e[tag=stone_init] run fill ~ ~1 ~ ~ ~1 ~1 stone
execute at @a[tag=placer,scores={p_rot=3},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[180f],Tags:["stone_door","stone_rot3"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:0},Count:1}],NoGravity:1,Pose:{Head:[0f,0.000001f,0f]},Invisible:1}
execute at @a[tag=placer,scores={p_rot=3},limit=1] run execute at @e[tag=stone_init] run fill ~ ~1 ~ ~-1 ~1 ~ stone
execute at @a[tag=placer,scores={p_rot=4},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[270f],Tags:["stone_door","stone_rot4"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:0},Count:1}],NoGravity:1,Pose:{Head:[0f,0.000001f,0f]},Invisible:1}
execute at @a[tag=placer,scores={p_rot=4},limit=1] run execute at @e[tag=stone_init] run fill ~ ~1 ~ ~ ~1 ~-1 stone
execute at @a[tag=placer,limit=1] run execute at @e[tag=stone_init] run give @p minecraft:tripwire_hook{display:{Name:"{\"text\":\"Key\"}"}}

tag @a[tag=placer] remove placer
kill @e[tag=stone_init]
kill @e[tag=sp1]

scoreboard players add @e[tag=stone_door] stone_open 0
execute at @a[nbt={SelectedItem:{id:"minecraft:tripwire_hook",tag:{display:{Name:"{\"text\":\"Key\"}"}}}}] run execute at @e[tag=stone_door,distance=..5] run particle enchant ~ ~1.5 ~ 0 0.5 0 0.01 5
execute at @a[nbt={SelectedItem:{id:"minecraft:tripwire_hook",tag:{display:{Name:"{\"text\":\"Key\"}"}}}},scores={talk=1..}] run scoreboard players set @e[tag=stone_door,distance=..3,limit=1,sort=nearest,scores={stone_open=0}] stone_open 1
execute at @a[nbt={SelectedItem:{id:"minecraft:tripwire_hook",tag:{display:{Name:"{\"text\":\"Key\"}"}}}},scores={talk=1..}] run scoreboard players set @e[tag=stone_door,distance=..3,limit=1,sort=nearest,scores={stone_open=49..}] stone_open -1

scoreboard players add @e[tag=stone_door,scores={stone_open=1..49}] stone_open 1
scoreboard players remove @e[tag=stone_door,scores={stone_open=-50..-1}] stone_open 1


execute at @e[tag=stone_rot2,scores={stone_open=-25}] run fill ~-1 ~1 ~ ~-2 ~1 ~1 barrier 
execute at @e[tag=stone_rot2,scores={stone_open=25}] run fill ~-1 ~1 ~ ~-2 ~1 ~1 air 

execute at @e[tag=stone_rot1,scores={stone_open=-25}] run fill ~ ~1 ~1 ~1 ~1 ~2 barrier 
execute at @e[tag=stone_rot1,scores={stone_open=25}] run fill ~ ~1 ~1 ~1 ~1 ~2 air 

execute at @e[tag=stone_rot3,scores={stone_open=-25}] run fill ~ ~1 ~-1 ~-1 ~1 ~-2 barrier 
execute at @e[tag=stone_rot3,scores={stone_open=25}] run fill ~ ~1 ~-1 ~-1 ~1 ~-2 air 

execute at @e[tag=stone_rot4,scores={stone_open=-25}] run fill ~1 ~1 ~ ~2 ~1 ~-1 barrier 
execute at @e[tag=stone_rot4,scores={stone_open=25}] run fill ~1 ~1 ~ ~2 ~1 ~-1 air 


scoreboard players remove @e[tag=stone_door,scores={stone_open=1..48}] stone_rot 1
scoreboard players add @e[tag=stone_door,scores={stone_open=-48..-1}] stone_rot 1
scoreboard players set @e[tag=stone_door,scores={stone_open=-50}] stone_open 0


execute at @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b}] run tag @e[tag=stone_door,distance=..2] add stone_kill
execute at @e[tag=stone_kill] run data merge entity @e[tag=stone_villager,limit=1,sort=nearest] {Health:0,DeathTime:19}
execute at @e[tag=stone_kill] run particle smoke ~ ~2 ~ 0.3 0.3 0.3 0.05 40 force
execute at @e[tag=stone_kill] run fill ~-2 ~1 ~-2 ~2 ~1 ~2 air replace barrier
execute at @e[tag=stone_kill] run kill @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b},sort=nearest,limit=1]
kill @e[tag=stone_kill]





################################################################ Bookshelf ############################################################


execute as @e[tag=sp2] at @s align xyz run summon armor_stand ~0.5 ~ ~0.5 {Tags:["stone_init"],Invisible:1}
execute at @e[tag=bookshelve_door] run kill @e[tag=stone_init,distance=..4]
execute as @e[tag=sp2] at @s run tag @p add placer
execute at @a[tag=placer,scores={p_rot=1},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[90f],Tags:["bookshelve_door","bookshelve_rot1"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=1},limit=1] run execute at @e[tag=stone_init] run summon villager ~ ~0.65 ~0.65 {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=1},limit=1] run execute at @e[tag=stone_init] run summon villager ~ ~0.65 ~-0.65 {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=1},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~1 ~ ~ {Rotation:[90f],Tags:["bookslide1","bookslide"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=1},limit=1] run execute at @e[tag=stone_init] run fill ~1 ~1 ~ ~ ~ ~ barrier


execute at @a[tag=placer,scores={p_rot=2},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[180f],Tags:["bookshelve_door","bookshelve_rot2"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=2},limit=1] run execute at @e[tag=stone_init] run summon villager ~0.65 ~0.65 ~ {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=2},limit=1] run execute at @e[tag=stone_init] run summon villager ~-0.65 ~0.65 ~ {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=2},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~1 {Rotation:[0f],Tags:["bookslide2","bookslide"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=2},limit=1] run execute at @e[tag=stone_init] run fill ~ ~1 ~1 ~ ~ ~ barrier


execute at @a[tag=placer,scores={p_rot=3},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[270f],Tags:["bookshelve_door","bookshelve_rot3"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=3},limit=1] run execute at @e[tag=stone_init] run summon villager ~ ~0.65 ~0.65 {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=3},limit=1] run execute at @e[tag=stone_init] run summon villager ~ ~0.65 ~-0.65 {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=3},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~-1 ~ ~ {Rotation:[-90f],Tags:["bookslide3","bookslide"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=3},limit=1] run execute at @e[tag=stone_init] run fill ~-1 ~1 ~ ~ ~ ~ barrier


execute at @a[tag=placer,scores={p_rot=4},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~ {Rotation:[-180f],Tags:["bookshelve_door","bookshelve_rot4"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=4},limit=1] run execute at @e[tag=stone_init] run summon villager ~0.65 ~0.65 ~ {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=4},limit=1] run execute at @e[tag=stone_init] run summon villager ~-0.65 ~0.65 ~ {Tags:["bookshelve_villager","iv"],NoGravity:1,NoAI:1,Offers:{},Invulnerable:1,Silent:1}
execute at @a[tag=placer,scores={p_rot=4},limit=1] run execute at @e[tag=stone_init] run summon armor_stand ~ ~ ~-1 {Rotation:[0f],Tags:["bookslide4","bookslide"],ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1}],NoGravity:1,Invisible:1}
execute at @a[tag=placer,scores={p_rot=4},limit=1] run execute at @e[tag=stone_init] run fill ~ ~1 ~-1 ~ ~ ~ barrier



execute at @a[tag=placer] run execute at @e[tag=stone_init] run scoreboard players set @e[tag=bookshelve_door,limit=1,sort=nearest] book_open 34
execute at @a[tag=placer] run execute at @e[tag=stone_init] run give @p minecraft:diamond_pickaxe{Unbreakable:1,display:{Name:"{\"text\":\"Book\"}"},Damage:3,HideFlags:63} 1
tag @a[tag=placer] remove placer
kill @e[tag=stone_init]
kill @e[tag=sp2]

execute at @a[scores={talk=1..}] run tag @e[tag=bookshelve_door,distance=..3,limit=1,sort=nearest] add door_toggle


scoreboard players set @e[tag=door_toggle,scores={book_open=..-34}] book_open 1
execute as @e[tag=door_toggle,scores={book_open=34..}] at @s run execute at @a[nbt={SelectedItem:{id:"minecraft:diamond_pickaxe",tag:{display:{Name:"{\"text\":\"Book\"}"}}}},scores={talk=1..},distance=..3] run scoreboard players set @s book_open -1

#execute at @a[nbt={SelectedItem:{id:"minecraft:diamond_pickaxe",tag:{display:{Name:"{\"text\":\"Book\"}"}}}},scores={talk=1..}] run scoreboard players set @e[tag=bookshelve_door,distance=..3,limit=1,sort=nearest,scores={book_open=34..}] book_open -1

#execute as @a[scores={talk=1..}] at @s run scoreboard players set @e[tag=bookshelve_door,distance=..3,limit=1,sort=nearest,scores={book_open=..-34}] book_open 1

tag @e[tag=door_toggle] remove door_toggle


scoreboard players add @e[tag=bookshelve_door] book_open 0

scoreboard players add @e[tag=bookshelve_door,scores={book_open=1..33}] book_open 1
scoreboard players remove @e[tag=bookshelve_door,scores={book_open=-33..-1}] book_open 1


execute as @e[tag=bookshelve_door,scores={book_open=1..}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1}]}
execute as @e[tag=bookshelve_door,scores={book_open=..-1}] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:1},Count:1}]}
execute as @e[tag=bookshelve_door,scores={book_open=2}] at @s run give @p minecraft:diamond_pickaxe{Unbreakable:1,display:{Name:"{\"text\":\"Book\"}"},Damage:3,HideFlags:63} 1
execute as @e[tag=bookshelve_door,scores={book_open=-2}] at @s run clear @p diamond_pickaxe{Damage:3} 1

execute as @e[tag=bookshelve_rot1,scores={book_open=2..30}] at @s run execute as @e[tag=bookslide1,limit=1,sort=nearest] at @s run tp @s ~0.0329 ~ ~ 
execute as @e[tag=bookshelve_rot1,scores={book_open=-30..-2}] at @s run execute as @e[tag=bookslide1,limit=1,sort=nearest] at @s run tp @s ~-0.0329 ~ ~ 
execute as @e[tag=bookshelve_rot1,scores={book_open=30}] at @s run fill ~1 ~ ~ ~ ~1 ~ barrier
execute as @e[tag=bookshelve_rot1,scores={book_open=-30}] at @s run fill ~1 ~ ~ ~1 ~1 ~ air

execute as @e[tag=bookshelve_rot2,scores={book_open=2..30}] at @s run execute as @e[tag=bookslide2,limit=1,sort=nearest] at @s run tp @s ~ ~ ~0.0329 
execute as @e[tag=bookshelve_rot2,scores={book_open=-30..-2}] at @s run execute as @e[tag=bookslide2,limit=1,sort=nearest] at @s run tp @s ~ ~ ~-0.0329 
execute as @e[tag=bookshelve_rot2,scores={book_open=30}] at @s run fill ~ ~ ~1 ~ ~1 ~ barrier
execute as @e[tag=bookshelve_rot2,scores={book_open=-30}] at @s run fill ~ ~ ~1 ~ ~1 ~1 air

execute as @e[tag=bookshelve_rot3,scores={book_open=2..30}] at @s run execute as @e[tag=bookslide3,limit=1,sort=nearest] at @s run tp @s ~-0.0329 ~ ~ 
execute as @e[tag=bookshelve_rot3,scores={book_open=-30..-2}] at @s run execute as @e[tag=bookslide3,limit=1,sort=nearest] at @s run tp @s ~0.0329 ~ ~ 
execute as @e[tag=bookshelve_rot3,scores={book_open=30}] at @s run fill ~-1 ~ ~ ~ ~1 ~ barrier
execute as @e[tag=bookshelve_rot3,scores={book_open=-30}] at @s run fill ~-1 ~ ~ ~-1 ~1 ~ air

execute as @e[tag=bookshelve_rot4,scores={book_open=2..30}] at @s run execute as @e[tag=bookslide4,limit=1,sort=nearest] at @s run tp @s ~ ~ ~-0.0329 
execute as @e[tag=bookshelve_rot4,scores={book_open=-30..-2}] at @s run execute as @e[tag=bookslide4,limit=1,sort=nearest] at @s run tp @s ~ ~ ~0.0329 
execute as @e[tag=bookshelve_rot4,scores={book_open=30}] at @s run fill ~ ~ ~-1 ~ ~1 ~ barrier
execute as @e[tag=bookshelve_rot4,scores={book_open=-30}] at @s run fill ~ ~ ~-1 ~ ~1 ~-1 air


execute at @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b}] run tag @e[tag=bookshelve_door,distance=..3] add book_kill
execute at @e[tag=book_kill] run execute as @e[tag=bookshelve_villager,limit=2,sort=nearest] run data merge entity @s {Health:0,DeathTime:19}
execute at @e[tag=book_kill] run kill @e[tag=bookslide,limit=1,sort=nearest]
execute at @e[tag=book_kill] run particle smoke ~ ~2 ~ 0.5 0.5 0.5 0.05 40 force
execute at @e[tag=book_kill] run fill ~-1 ~ ~-1 ~1 ~1 ~1 air replace barrier
execute at @e[tag=book_kill] run fill ~ ~ ~ ~ ~1 ~ air
execute at @e[tag=book_kill] run kill @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b},sort=nearest,limit=1]
kill @e[tag=book_kill]






########################################################################### Hidden Wall #######################################################################

execute at @a[scores={p_rot=1}] run execute at @e[tag=sp4,limit=1,distance=..4] run summon armor_stand ~ ~ ~1 {Tags:["c","c_door"],NoGravity:1,Invisible:1,Marker:1}
execute at @a[scores={p_rot=2}] run execute at @e[tag=sp4,limit=1,distance=..4] run summon armor_stand ~-1 ~ ~ {Tags:["c","c_door"],NoGravity:1,Invisible:1,Marker:1}
execute at @a[scores={p_rot=3}] run execute at @e[tag=sp4,limit=1,distance=..4] run summon armor_stand ~ ~ ~-1 {Tags:["c","c_door"],NoGravity:1,Invisible:1,Marker:1}
execute at @a[scores={p_rot=4}] run execute at @e[tag=sp4,limit=1,distance=..4] run summon armor_stand ~1 ~ ~ {Tags:["c","c_door"],NoGravity:1,Invisible:1,Marker:1}
execute at @e[tag=sp4] run scoreboard players set @e[tag=c_door,distance=..4] cloud_door -10
kill @e[tag=sp4]

scoreboard players remove @e[tag=c_door] cloud_door 1

execute at @a run execute at @e[tag=c_door,scores={cloud_door=0}] run particle cloud ~ ~0.7 ~ 0.5 1 0.5 0.02 20
execute at @a run execute at @e[tag=c_door,scores={cloud_door=0}] run clone ~ 0 ~ ~ 1 ~ ~ ~ ~ replace move 

execute at @a run execute at @e[tag=c_door,distance=..2,scores={cloud_door=..3}] run particle cloud ~ ~0.7 ~ 0.5 1 0.5 0.02 20
execute at @a run execute at @e[tag=c_door,distance=..2,scores={cloud_door=..3}] run clone ~ ~ ~ ~ ~1 ~ ~ 0 ~ replace move
execute at @a run scoreboard players set @e[tag=c_door,distance=..2] cloud_door 5


#execute at @e[tag=c_door,scores={cloud_door=..-10}] if block ~ ~1 ~ air run kill @e[tag=c_door,limit=1,sort=nearest]


execute at @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b}] run tag @e[tag=c_door,distance=..3] add c_kill
execute at @e[tag=c_kill] run particle smoke ~ ~2 ~ 0.5 0.5 0.5 0.05 40 force
execute at @e[tag=c_kill] run fill ~ ~ ~ ~ ~1 ~ air
execute at @e[tag=c_kill] run kill @e[type=item,nbt={Item:{id:"minecraft:tnt",tag:{display:{Name:"{\"text\":\"Remove Door\"}"}}},OnGround:1b},sort=nearest,limit=1]
kill @e[tag=c_kill]







tag @a remove give
scoreboard players set @a talk 0
scoreboard players set @a sneak 0
scoreboard players set @a rc 0
